# coding: utf-8

"""
    perceptic-core-server API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1-SNAPSHOT
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from perceptic_core_client.models.azure_blob_connection_settings_api_dto import AzureBlobConnectionSettingsApiDto
from perceptic_core_client.models.s3_connection_settings_api_dto import S3ConnectionSettingsApiDto
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

CONNECTIONSETTINGSAPIDTO_ONE_OF_SCHEMAS = ["AzureBlobConnectionSettingsApiDto", "S3ConnectionSettingsApiDto"]

class ConnectionSettingsApiDto(BaseModel):
    """
    ConnectionSettingsApiDto
    """
    # data type: S3ConnectionSettingsApiDto
    oneof_schema_1_validator: Optional[S3ConnectionSettingsApiDto] = None
    # data type: AzureBlobConnectionSettingsApiDto
    oneof_schema_2_validator: Optional[AzureBlobConnectionSettingsApiDto] = None
    actual_instance: Optional[Union[AzureBlobConnectionSettingsApiDto, S3ConnectionSettingsApiDto]] = None
    one_of_schemas: Set[str] = { "AzureBlobConnectionSettingsApiDto", "S3ConnectionSettingsApiDto" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ConnectionSettingsApiDto.model_construct()
        error_messages = []
        match = 0
        # validate data type: S3ConnectionSettingsApiDto
        if not isinstance(v, S3ConnectionSettingsApiDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `S3ConnectionSettingsApiDto`")
        else:
            match += 1
        # validate data type: AzureBlobConnectionSettingsApiDto
        if not isinstance(v, AzureBlobConnectionSettingsApiDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AzureBlobConnectionSettingsApiDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ConnectionSettingsApiDto with oneOf schemas: AzureBlobConnectionSettingsApiDto, S3ConnectionSettingsApiDto. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ConnectionSettingsApiDto with oneOf schemas: AzureBlobConnectionSettingsApiDto, S3ConnectionSettingsApiDto. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `AzureBlobConnectionSettingsApiDto`
        if _data_type == "v1/blob":
            instance.actual_instance = AzureBlobConnectionSettingsApiDto.from_json(json_str)
            return instance

        # check if data type is `S3ConnectionSettingsApiDto`
        if _data_type == "v1/s3":
            instance.actual_instance = S3ConnectionSettingsApiDto.from_json(json_str)
            return instance

        # check if data type is `AzureBlobConnectionSettingsApiDto`
        if _data_type == "AzureBlobConnectionSettingsApiDto":
            instance.actual_instance = AzureBlobConnectionSettingsApiDto.from_json(json_str)
            return instance

        # check if data type is `S3ConnectionSettingsApiDto`
        if _data_type == "S3ConnectionSettingsApiDto":
            instance.actual_instance = S3ConnectionSettingsApiDto.from_json(json_str)
            return instance

        # deserialize data into S3ConnectionSettingsApiDto
        try:
            instance.actual_instance = S3ConnectionSettingsApiDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AzureBlobConnectionSettingsApiDto
        try:
            instance.actual_instance = AzureBlobConnectionSettingsApiDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ConnectionSettingsApiDto with oneOf schemas: AzureBlobConnectionSettingsApiDto, S3ConnectionSettingsApiDto. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ConnectionSettingsApiDto with oneOf schemas: AzureBlobConnectionSettingsApiDto, S3ConnectionSettingsApiDto. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AzureBlobConnectionSettingsApiDto, S3ConnectionSettingsApiDto]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


